# Guidelines for Contributing

## Issues and Feature Requests

Important: **We do not provide customer support on GitHub.** 

Although we monitor issues reported on GitHub, we cannot guarantee to process them as soon and in the same manner as tickets submitted to the [Support Center](https://www.devexpress.com/sc).

Our official bug tracker is the [Support Center](https://www.devexpress.com/sc). Please submit your questions, bug reports, and feature requests there.

If you find a security bug, please report it by sending an email to info@devexpress.com.

## Working with Code

[This guide](README_DEVELOPERS.md) describes how to build DevExtreme and run tests.

## Contributing Code and Content

Important: **Read Section 5 of the [LICENSE AGREEMENT](LICENSE.md#5-submission-of-contributions) before submitting any contribution.** 

Please keep in mind that DevExtreme has a development schedule; we are unable to accept every pull request from non-DevExpress contributors.

However, you are welcome to fork the repository, modify the source code in your fork, and make your builds.

To submit a pull request, follow these guidelines:

1. Describe all applied changes in detail 
2. Make sure that all [automatic checks](README_DEVELOPERS.md#tests-and-ci) pass
